from _add_use_case_scripts.requestPost  import postLayersToSwagger, postTableToSwagger

def add_table(use_case: str, table_name: str):
    '''
    take the columns and add the mappings at the server
    replace all "/"'s in the internal representation with a "_"
    '''

    columns = [
        "travelId"        
    ]    
    columns = { c : c for c in columns }
    columns["UniqueID"] = "travelId+user"
    columns["moment"] = "travel//finishedBy[0]//moment"
    columns["latitude"] = "travel//finishedBy[0]//endPlace//latitude"
    columns["longitude"] = "travel//finishedBy[0]//endPlace//longitude"
    columns["user"] = "travel//finishedBy[0]//user"

    table = {
        "name": table_name,
        "mappings": columns
    }

    postTableToSwagger(use_case,table)

def add_layers(use_case:str, table_name: str):
    layers = [
        {
            "use_case": use_case,
            "table": table_name,
            "name": "FinishedByAtLocation_Layer",
            "properties": [
                'UniqueID',
                'travelId',
                'moment',
                'latitude',
                'longitude',
                'user'
            ],
            "cluster_properties": [
                'latitude',
                'latitude'
            ]
        },{
            "use_case": use_case,
            "table": table_name,
            "name": "FinishedByAtMoment_Layer",
            "properties": [
                'UniqueID',
                'travelId',
                'moment',
                'latitude',
                'longitude',
                'user'
            ],
            "cluster_properties": [
                'moment'
            ]
        }
    ]

    postLayersToSwagger(use_case,layers)

def main(use_case: str):
    print("TRAVEL_FinishedBy")
    table_name = "travelFinishedBy"
    add_table(use_case,table_name)
    add_layers(use_case, table_name)
