from _add_use_case_scripts.requestPost  import postLayersToSwagger, postTableToSwagger

def add_table(use_case: str, table_name: str):
    '''
    take the columns and add the mappings at the server
    replace all "/"'s in the internal representation with a "_"
    '''

    columns = [
        "travelId"        
    ]    
    columns = { c : c for c in columns }
    columns["UniqueID"] = "travelId+user"
    columns["isDriver"] = "travel//users[0]//userIdisDriver"
    columns["passengersNr"] = "ravel//users[0]//passengers"
    columns["user"] = "travel//users[0]//userId"

    table = {
        "name": table_name,
        "mappings": columns
    }

    postTableToSwagger(use_case,table)

def add_layers(use_case:str, table_name: str):
    layers = [
        {
            "use_case": use_case,
            "table": table_name,
            "name": "Driver_layer",
            "properties": [
                'UniqueID',
                'travelId',
                'isDriver',
                'passengersNr',
                'user'
                
            ],
            "cluster_properties": [
                'isDriver'
            ]
        },{
            "use_case": use_case,
            "table": table_name,
            "name": "Passangers_layer",
            "properties": [
                'UniqueID',
                'travelId',
                'isDriver',
                'passengersNr',
                'user'
                
            ],
            "cluster_properties": [
                'passengersNr'
            ]
        }
    ]

    postLayersToSwagger(use_case,layers)

def main(use_case: str):
    print("TRAVEL_USERS")
    table_name = "travelUsers"
    add_table(use_case,table_name)
    add_layers(use_case, table_name)
